#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

#include <server.h>
#include <structures.h>
#include <custom_sem.h>
#include <custom_shm.h>
#include <errExit.h>

void sigHandler(int sig) {
    //TODO:
    exit(0);
}


int main(int argc, char *argv[]){
    input_server_t input = check_input(argc, argv);

    int shmBoardid = getShmid(input.rows, input.collums);
    tile_t *board = shmServerAt(shmBoardid);

    // si potrebbe mettere in server.c
    int semid = getSemid(ftok(KEYFILE, 'k'), 2);

    sigset_t mySet;
    sigfillset(&mySet);
    sigdelset(&mySet, SIGINT);
    sigprocmask(SIG_SETMASK, &mySet, NULL);

    if (signal(SIGINT, sigHandler) == SIG_ERR)
        errExitMsg("signal");


    resetServerSem(semid);

    semOp(semid, 0, 2); // aperurta semaforo per connessione dei due client
    semOp(semid, 0, 0); // aspetto che si connettano i due client


    // faccio quello che devo fare


    


    return 0;
}