#ifndef STRUCTURES_H
#define STRUCTURES_H


// semaphore
union semun {
    int val;
    struct semid_ds * buf;
    unsigned short * array;
};

// shared memory
#define KEYFILE "../LICENSE"
#define SHMERR (void *)-1

typedef struct {
    int collums;
    int rows;
    char player1Token;
    char player2Token;
} input_server_t;

typedef enum {
    EMPTY,
    PLAYER1,
    PLAYER2
} tile_t;

// signal
#define DEFAULT_SIGINT 2
#define TIME_TO_RESET 10

//message queue
typedef struct {
    long mtype;
    int board_id;
    input_server_t server_in;
    char *name_player1, *name_player2;
} msgq_t;

#endif